#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define MAX 1000
#define maxnseqs 300  /*verify NSM in function sk*/

char *oldseq(FILE *, int, int);
char *oldname(FILE *);
void newseq(FILE *, int, int, char **, char **, int);
int epur(int, int, char **, char **, int, int);
int has1_n(int);
int preneigojodist(int, int, char **, double **, double **, double **, double **, double **, double **, int, int, int, int, int, double);
int neigojodist(int, int, double **, double **, double **, double **, double **, double **, int, int, int, int, int, double);
int calcpercent(int, int, char **, double **, double, int, int, int, int, int);
/*int galtgouy (int, int, char **, double **, double, int, int, double, int);*/
void printerror(void);
void sk(double **, char **, int **, int, FILE *, double *);


double a, b, MOY;
int kind=2, betap=1;
int transiversions=2;
int FINAL=0;


int has1_n(int nn)
{
	static double   l = 32767.0;
	return ( (int)(rand() * (double)nn / l) + 1);
}
 

int main(int argc, char *argv[])
{
	/*const int       maxnseqs = 300;*/
	char           *seq[maxnseqs], *bootseq[maxnseqs], *seqname[maxnseqs];
	char            infilename[40], outfilename[40], distribfilename[40], synofilename[40], nonsynofilename[40], line[MAX+1];
	int             i, j, ii, jj, kk, k, Nseq, Nsites, *clusters[3], *bootclust[3], hsites, hcodons[10000], *resulbranches,
			nbiterations, Ncompar, *listbranche[maxnseqs], sat, nbsat, fin, R, r, s, Opt, opt, L, format, interleaved,
			invar, empiri, dist, distrib;
	double          *ka[maxnseqs], *bootka[maxnseqs], *n[maxnseqs], *bootn[maxnseqs], 
			*nd[maxnseqs*maxnseqs/2], *bootnd[maxnseqs*maxnseqs/2], *ad[maxnseqs*maxnseqs/2], *bootad[maxnseqs*maxnseqs/2], 
			*sd[maxnseqs*maxnseqs/2], *bootsd[maxnseqs*maxnseqs/2], *as[maxnseqs*maxnseqs/2], *bootas[maxnseqs*maxnseqs/2], 
			t, apriori;
	FILE           *infile, *outfile, *distribfile, *synofile, *nonsynofile;
	double         *branches, *bootbranches, maxbr, tampon, *bootvalues;
	long int        pos;
	int		typedata, clear;



	printf("\n********************************************************************\n");
	printf("\n<Program BOOTSK: performs bootstrapping of phylogenetic trees estimated\n");
	printf("   by means of the Neibourgh-Joining Method>\n");
	
	strcpy(infilename, argv[1]);
	/*printf("Name of sequence file? (phylip format)\n");
	scanf("%s", infilename);*/
	L=strlen(infilename);
	infilename[L]='\0';
	if ((infile = fopen(infilename, "r")) == NULL) {
		printf("Error opening input file\n");
		exit(1);
		}

	printf("\nprotein-encoding genes <1> or not <2> ?\n");
	scanf("%d", &typedata);

	if(typedata==2) {
		printf("Choose the distance you want to use: (input a number)\n");
		/*printf("Jukes/Cantor?       1\nKimura?             2\nNei/Gojobori?       3\nGaltier/Gouy?       4\nprotein divergence? 5\n");*/
		printf("Jukes/Cantor?            2\nKimura?                  3\nTransversional distance? 4\n");
		scanf("%d", &s);

		if(s==2) Opt=1;
		if(s==3) Opt=2;
		if(s==4) { Opt=2;transiversions=1; }
		/*if(Opt==2) {
			printf("Do you want to compute only transversional distances? (Yes=1, No=2)\n");
			scanf("%d", &transiversions);
			}*/

		printf("\nDo you want to delete undefined characters in all sequences <1> or specifically for each sequence pair <2>?\n");
		scanf("%d", &clear);
		}
	
	if(typedata==1) Opt=3;
	if(Opt==3) {
		printf("Jukes-and-Cantor-like distance <1> or Kimura-like distance <2>?\n");
		scanf("%d", &s);
		if(s==1) r=2;
		if(s==2) r=1;
		/*if(r==1) {
			printf("Do you want to compute only transversional distances? (Yes=1, No=2)\n");
			scanf("%d", &transiversions);
			}*/
		printf("Do you want to compute:\nsynonymous distances?     1\nnonsynonymous distances?  2\n");
		scanf("%d", &dist);
		}

	/*if(Opt==4) {
		printf("Compute transi/transv ratio by: \n");
		printf("	- the 2-parameter model (constant value)?   1\n");
		printf("	- the 2-parameter model (variable value)?   2\n");
		printf("	- a priori (constant value)?                3\n");
		scanf("%d", &opt);
		if (opt==3){
			printf("Input value?\n");
			scanf("%lf", &apriori);
			}
		}*/

	printf("Do you want to correct the distances for rate variation among sites? (Yes=1, No=2)\n");
	scanf("%d", &R);
	if(R==2 && Opt==5) {
			printf("Do you want to use the empirical distance of Kimura? (Yes=1, No=2)\n");
			scanf("%d", &empiri);
			}
	if(R==1) {
		/*printf("Do you want to fit:\na continuous gamma distribution? 1\na discrete gamma distribution?   2\n\n");
		scanf("%d", &distrib);*/
		distrib=2;
		if( distrib==2 && Opt==3 && dist==1 ) {
				/*printf("What's the name of the synonymous distribution file?\n");
				scanf("%s", synofilename);
				if( (synofile=fopen(synofilename,"r"))==NULL ) {
						printf("can't open synonymous distribution file!\n");
						exit(-1);
						}*/
				printf("What's the mean of the observed synonymous distribution?\n");
				/*printf("<Enter the mean of the distribution per codon. This mean will be divided by the mean number of synonymous sites per codon to give the mean per site.>\n");*/
				scanf("%lf", &MOY);
				printf("MOY=%f\n", MOY);
				}
		if( distrib==2 && Opt==3 && dist==2 ) {
				/*printf("What's the name of the nonsynonymous distribution file?\n");
				scanf("%s", nonsynofilename);
				if( (nonsynofile=fopen(nonsynofilename,"r"))==NULL ) {
						printf("can't open nonsynonymous distribution file!\n");
						exit(-1);
						}*/
				printf("What's the mean of the observed nonsynonymous distribution?\n");
				/*printf("<Enter the mean of the distribution per codon. This mean will be divided by the mean number of nonsynonymous sites per codon to give the mean per site.>\n");*/
				scanf("%lf", &MOY);
				printf("MOY=%f\n", MOY);
				}
		if( distrib==2 && (Opt==1 || Opt==2 || Opt==4 || Opt==5) ) {
				/*printf("What's the name of the distribution file?\n");
				scanf("%s", distribfilename);
				if( (distribfile=fopen(distribfilename,"r"))==NULL ) {
						printf("can't open distribution file!\n");
						exit(-1);
						}*/
				printf("What's the mean of the observed distribution?\n");
				scanf("%lf", &MOY);
				printf("MOY=%f\n", MOY);
				}

		printf("What's the value of a?\n");
		scanf("%lf", &a);
		printf("a=%f\n", a);
		
		if( distrib==2 ) {
			/*printf("Do you want to fit also the beta parameter (Yes=1, No=2)?\n");
			scanf("%d", &betap);*/
			if(betap==2) {
				printf("<In that case, the beta value will be fixed so that the mean of the expected distribution equals the mean of the observed one.>\n");
				b=0.0;
				}
			else {
				printf("What's the value of b?\n");
				scanf("%lf", &b);
				printf("b=%f\n", b);
				}
			}

		/*printf("Do you want to take into account the invariant sites? (Yes=1, No=2)\n");
		scanf("%d", &invar);*/
		invar=1;
		if(invar==1) {
			printf("What's the value of t?\n");
			scanf("%lf", &t);
			printf("t=%f\n", t);
			}
		else t=0.0;		
		}


	/*create and open the output file ".boot" */
	/*strncpy(outfilename, infilename, (L));
	outfilename[L]='\0';
	if(Opt==1) strcat(outfilename, ".jcboot");
	else if(Opt==2) {
		if(transiversions==1) strcat(outfilename, ".kimtrvboot");
		else strcat(outfilename, ".kimboot");
		}
	else if(Opt==3) {
		if(transiversions==1) strcat(outfilename, ".ngtrvboot");
		else strcat(outfilename, ".ngboot");
		}
	else if(Opt==4) strcat(outfilename, ".ggboot");
	else strcat(outfilename, ".proboot");	
	if ( (outfile=fopen(outfilename,"w") )==NULL) {
				fprintf(stderr, "can't open output file (.boot)\n");
				exit(1);
				}*/

	/*create and open the output file ".boot" */
	strncpy(outfilename, infilename, (L));
	outfilename[L]='\0';
	if(R==1) {
		/*if(typedata==2 && clear==1) strcat(outfilename, "clearedbin.boot");*/
		strcat(outfilename, "bin.boot");
		}
	else {
		/*if(typedata==2 && clear==1) strcat(outfilename, "clearednc.boot");*/
		strcat(outfilename, "nc.boot");
		}
	if ( (outfile=fopen(outfilename,"w") )==NULL) {
				fprintf(stderr, "can't open output file (.boot)\n");
				exit(1);
				}
	

	/*if(R==1) {
		fprintf(outfile, "a=%f", a);
		if(betap==1) fprintf(outfile, ", b=%f", b);
		if(invar==1) fprintf(outfile, ", t=%f", t);
		if(distrib==2) fprintf(outfile, ", MOY=%f\n\n", MOY);
		else fprintf(outfile, "\n\n");
		}*/

	printf("Number of iterations ?\n");
	scanf("%d", &nbiterations);


	/*read the header*/
	fscanf(infile, "%d %d", &Nseq, &Nsites);
	/*printf("%d sequences, %d sites\n", Nseq, Nsites);*/
	if( (fgets(line, MAX, infile))==NULL ) {
				printf("err_fgets\n");
				exit(1);
				}
	pos=ftell(infile);
	interleaved=0;
	for(i=0; i<=20; i++) {
		format=fgetc(infile);
		if(format=='\n') {
			fseek(infile, pos, 0);
			/*read all the sequences in old phylip format*/
			for(j=0; j<Nseq; j++) {
				seqname[j]=oldname(infile);
				seq[j]=oldseq(infile, Nsites, Opt);
				}
			interleaved=1;
			break;
			}
		}
	if(interleaved!=1) {
			fseek(infile, pos, 0);
			newseq(infile, Nseq, Nsites, seq, seqname, Opt); /*read all the sequences in new phylip format*/
			}

	/*don't take into account undefined nucleotides*/
	printf("\n%d sequences read.\n\n", Nseq);
	if(Opt!=5) Nsites=epur(Nseq, Nsites, seq, seqname, typedata, clear);
	/*for(i=0; i<Nseq; i++) printf("%s,%s\n", seqname[i], seq[i]);*/


	if( (clusters[1] = (int *) malloc(Nseq * sizeof(int)))==NULL ) printerror();
	if( (bootclust[1] = (int *) malloc(Nseq * sizeof(int)))==NULL ) printerror();
	if( (clusters[2] = (int *) malloc(Nseq * sizeof(int)))==NULL ) printerror();
	if( (bootclust[2] = (int *) malloc(Nseq * sizeof(int)))==NULL ) printerror();

	maxbr = pow((double) 2, (double) (Nseq)) - (double) 1;

	if( (branches = (double *) malloc((Nseq - 1) * sizeof(double)))==NULL ) printerror();
	if( (bootbranches = (double *) malloc((Nseq - 1) * sizeof(double)))==NULL ) printerror();
	if( (resulbranches = (int *) malloc((Nseq - 1) * sizeof(int)))==NULL ) printerror();
	if( (bootvalues = (double *) malloc((Nseq - 1) * sizeof(double)))==NULL ) printerror();
	for (i = 1; i <= Nseq - 1; i++) 
		if( (listbranche[i] = (int *) malloc((Nseq + 1) * sizeof(int)))==NULL ) printerror();

	for (i = 0; i <= Nseq; i++) {
		if( (ka[i] = (double *) malloc((Nseq + 1) * sizeof(double)))==NULL ) printerror();
		if( (bootka[i] = (double *) malloc((Nseq + 1) * sizeof(double)))==NULL ) printerror();
		if(Opt==3) {
			if( (n[i] = (double *) malloc((Nsites/3+1) * sizeof(double)))==NULL ) printerror();
			if( (bootn[i] = (double *) malloc((Nsites/3+1) * sizeof(double)))==NULL ) printerror();
			}
		}

	Ncompar=( Nseq*(Nseq-1) )/2;
	printf("\n(%d comparisons)\n", Ncompar);
	if(Opt==3) for (i=0; i<=Ncompar; i++) {
				if( (nd[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (bootnd[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (ad[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (bootad[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (sd[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (bootsd[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (as[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				if( (bootas[i]=(double *)malloc((Nsites/3+1)*sizeof(double)))==NULL ) printerror();
				}


	/*INFER THE PHYLOGENY USING THE INPUT SEQUENCES. THIS IS THE REFERENCE TREE*/

	if(Opt==3) sat = preneigojodist(Nseq, Nsites, seq, ka, n, nd, ad, sd, as, R, r, invar, dist, distrib, t);
	/*else if(Opt==4) sat = galtgouy(Nseq, Nsites, seq, ka, t, R, opt, apriori, invar);*/
	else sat = calcpercent(Nseq, Nsites, seq, ka, t, Opt, R, invar, empiri, distrib);

	/*for(i=0; i<Nseq-1; i++) for(j=i+1; j<Nseq; j++) printf("ka[%d][%d]=%f,", i, j, ka[i][j]);*/

	for (i = 0; i < Nseq; i++) {
		*(ka[i] + i) = 0;
		for (j = i + 1; j < Nseq; j++) *(ka[j] + i) = *(ka[i] + j);
		}

	for (i = 0; i <= Nseq - 1; i++)
			for (j = 0; j <= Nseq - 1; j++) *(ka[Nseq - i] + Nseq - j) = *(ka[Nseq - i - 1] + Nseq - j - 1);

	/*for(i=0; i<=Nseq; i++) for(j=0; j<=Nseq; j++) printf("ka[%d][%d]=%f,", i, j, ka[i][j]);*/

	sk(ka, seqname, clusters, Nseq, outfile, bootvalues);
	/*for(ii=1; ii<=Nseq-3; ii++) printf("%d: %d,%d\n", ii, clusters[1][ii], clusters[2][ii]);*/


	for (ii = 1; ii <= Nseq - 3; ii++) {
		branches[ii] = (double) 0;
		for (jj = 1; jj <= 2; jj++) {
			if (*(clusters[jj] + ii) < 0) {
				for (kk = 1; kk <= ii; kk++) {
					if (abs(*(clusters[1] + ii - kk)) == abs(*(clusters[jj] + ii)))
						break;
					if (abs(*(clusters[2] + ii - kk)) == abs(*(clusters[jj] + ii)))
						break;
					}
				branches[ii] += branches[ii - kk];
				} 
			else branches[ii] += pow((double) 2, (double) (*(clusters[jj] + ii) - 1));
			}

		tampon = branches[ii];
		for (i = 1; i <= Nseq; i++) {
			j = Nseq - i;
			*(listbranche[ii] + j) = (int) (tampon / pow((double) 2, (double) j));
			tampon -= *(listbranche[ii] + j) * pow((double) 2, (double) j);
			}
		}

	/*for(i=1;i<=Nseq-3;i++) printf("br(%d)=%f\n", i, branches[i]);
	printf("maxbr=%f\n", maxbr);*/


	if(Opt==3) for(i=0; i<Nseq; i++) free(seq[i]);


			/* *************** START OF THE BOOTSTRAP PROCEDURE ************* */

	nbsat = fin = 0;

	if(Opt!=3) for(i=0; i<Nseq; i++) if( (bootseq[i]=(char *)malloc( (Nsites+1)*sizeof(char) ))==NULL ) printerror();
	/*else 	   if( (hcodons=(int *)malloc( (Nsites/3+1)*sizeof(int) ))==NULL ) printerror();*/

	
	for (ii = 1; ii <= Nseq - 3; ii++)
		resulbranches[ii] = 0;
	if(nbiterations>=10) printf("\nEach point represents 10 iterations.\n\n");
	for (k = 1; k <= nbiterations; k++) {
		if (k%10==0) printf(".");
		fflush(stdout);
		if (k%100==0) printf("\n");

		/*create bootstrapped sequences by random draw of sites*/
		if(Opt!=3) {       
			for (i = 0; i < Nsites; i++) {
				hsites= has1_n(Nsites) - 1;
				/*printf("h=%d,", hsites);*/
				for (j = 0; j < Nseq; j++) *(bootseq[j] + i) = *(seq[j] + hsites);
				}
			}

		else {
		 /*for the Nei and Gojobori's method, random draw of codons, not individual sites*/
			for (i = 0; i < Nsites / 3; i++) {
				hcodons[i] = has1_n(Nsites / 3) - 1;
				/*printf("hc[%d]=%d,", i, hcodons[i]);*/
				for (j = 0; j < Nseq; j++) bootn[j][i]=n[j][hcodons[i]];
				}
			for (i=0; i<Ncompar; i++) for(j=0; j<Nsites/3; j++) {
							bootnd[i][j]=nd[i][hcodons[j]];
							bootad[i][j]=ad[i][hcodons[j]];
							bootsd[i][j]=sd[i][hcodons[j]];
							bootas[i][j]=as[i][hcodons[j]];
							}
			}


			/*INFER THE PHYLOGENY USING THE BOOTSTRAPPED SEQUENCES*/
		if(Opt==3) sat = neigojodist(Nseq, Nsites, bootka, bootn, bootnd, bootad, bootsd, bootas, R, r, invar, dist, distrib, t);
		/*else if(Opt==4) sat = galtgouy(Nseq, Nsites, bootseq, bootka, t, R, opt, apriori, invar);*/
		else sat = calcpercent(Nseq, Nsites, bootseq, bootka, t, Opt, R, invar, empiri, distrib);

		if (sat == 0) {
			/*for(i=0; i<Nseq-1; i++) for(j=i+1; j<Nseq; j++) printf("bootka[%d][%d]=%f,", i, j, bootka[i][j]);*/
			for (i = 0; i < Nseq; i++) {
				*(bootka[i] + i) = 0;
				for (j = i + 1; j < Nseq; j++) *(bootka[j] + i) = *(bootka[i] + j);
				}

			for (i = 0; i <= Nseq - 1; i++)
				for (j = 0; j <= Nseq - 1; j++) *(bootka[Nseq - i] + Nseq - j) = *(bootka[Nseq - i - 1] + Nseq - j - 1);

			/*for(i=0; i<=Nseq; i++) for(j=0; j<=Nseq; j++) printf("bootka[%d][%d]=%f,", i, j, bootka[i][j]);*/


			sk(bootka, seqname, bootclust, Nseq, outfile, bootvalues);


			for (ii = 1; ii <= Nseq - 3; ii++) {
				bootbranches[ii] = (double) 0;
				for (jj = 1; jj <= 2; jj++) {
					if (*(bootclust[jj] + ii) < 0) {
						for (kk = 1; kk <= ii; kk++) {
							if (abs(*(bootclust[1] + ii - kk)) == abs(*(bootclust[jj] + ii)))
								break;
							if (abs(*(bootclust[2] + ii - kk)) == abs(*(bootclust[jj] + ii)))
								break;
							}
						bootbranches[ii] += bootbranches[ii - kk];
						} 
					else bootbranches[ii] += pow((double) 2, (double) (*(bootclust[jj] + ii)) - 1);
					}
				}

			/*compare the bootstrapped tree with the reference tree*/
			for (i = 1; i <= Nseq - 3; i++) {
				for (j = 1; j <= Nseq - 3; j++) {
					if ((branches[i] == bootbranches[j]) || (branches[i] + bootbranches[j] == maxbr))
						{
						resulbranches[i]++;
						break;
						}
					}
				}
			} 

		else nbsat++;

		if ((nbsat >= k / 10) && (k >= 5000)) {
			fin = 1;
			break;
			}
	}
	if (fin == 1) {
		printf("Too much saturation. \n");
		exit(1);
		}

	FINAL=1;
	for(i=1; i<=Nseq-3; i++) {
		bootvalues[i]=100*(double)resulbranches[i]/(nbiterations-nbsat);
		/*printf("bv=%f\n", bootvalues[i]);*/
		}

	sk(ka, seqname, clusters, Nseq, outfile, bootvalues);

	if (nbsat != 0) {
		printf("WARNING: %d iterations have not been taken into account\n", nbsat);
		printf("because of saturation between some pairs of sequences.\n\n");
		}

	/*fprintf(outfile, "\n\n            ");
	for (i = 1; i <= Nseq; i++)
		fprintf(outfile, "%d", i % 10);
	fprintf(outfile, "\n");
	for (i = 1; i <= Nseq - 3; i++) {
		fprintf(outfile, "branche %d= ", i);
		if (i / 10 == 0)
			fprintf(outfile, " ");
		for (j = 0; j <= Nseq - 1; j++)
			fprintf(outfile, "%d", *(listbranche[i] + j));
		fprintf( outfile,  " : %3d (%3.0f%%)\n", resulbranches[i], 100*(float)resulbranches[i]/(nbiterations-nbsat) );
		}
	fprintf(outfile, "\n");

	if (nbsat != 0) {
		fprintf(outfile, "WARNING: %d iterations have not been taken into account\n", nbsat);
		fprintf(outfile, "because of saturation between some pairs of sequences.\n\n");
		}
	fprintf(outfile, "Sequence names:\n");
	for (i = 0; i < Nseq; i++) fprintf(outfile, "%d : %s\n", i+1, seqname[i]);*/

	printf("\n");

exit(0);

}

void printerror(void)
{
printf("Not enough memory!\n");
exit(-1);
}
